dnl determines target-specific extensions and flags
AC_DEFUN([VISTALAB_FLAGS],[
	dnl Command Line Options
	AC_ARG_ENABLE(debug,
	 [  --enable-debug    Turn on debugging],
	 [case "${enableval}" in
	   yes) debug=true ;;
	   no)  debug=false ;;
	   *) AC_MSG_ERROR(bad value ${enableval} for --enable-debug) ;;
	 esac],[debug=false])

	dnl Target specific flags
	case $host in
	*-*-cygwin* | *-*-mingw*)
	WX_CONFIG_PLATFORM="msw"
	WX_CONFIG_CROSS="-i586-mingw32msvc"
	CROSS_CXXFLAGS="-DVISTA_BASEIMPORT"
	GL2PS_CXXFLAGS="-DGL2PSDLL"
	;;
	*-*-linux*)
	WX_CONFIG_PLATFORM="gtk${WX_GTK_EXTENSION}"
	WX_CONFIG_CROSS=""
	VISTALAB_LDFLAGS="$VISTALAB_LDFLAGS -Wl,-E"
	CROSS_CXXFLAGS=""
	GL2PS_CXXFLAGS=""
	;;
	*-*-*)
	GL2PS_CXXFLAGS=""
	;;	
	esac

	dnl Debug specifig flags
	DEBUGEXT=""
	if test x$debug = xtrue; then
	  DEBUGEXT="d"
	fi
	TUVISION_CONFIG="tuvision${DEBUGEXT}-config"
	WX_CONFIG_NAME="wx${WX_CONFIG_PLATFORM}${DEBUGEXT}-${WX_CONFIG_VERSION}${WX_CONFIG_CROSS}-config"
	VISTALAB_BASELIBS="-lvistalabbase${DEBUGEXT}"
        VISTALAB_UTILLIBS="-lvistalabutils${DEBUGEXT}"

	CXXFLAGS=""
	CFLAGS=""
	AM_CONDITIONAL(DEBUG, test x$debug = xtrue)

	])

AC_DEFUN([VISTALAB_USECONTRIB],[
	CONTRIB_SUBDIRS="$CONTRIB_SUBDIRS $1"
	NEWLIB_SRCPATH='$(top_srcdir)/contrib/'$1
	NEWLIB_BUILDPATH='$(top_builddir)/contrib/'$1
	CONTRIB_CXXFLAGS="$CONTRIB_CXXFLAGS -I$NEWLIB_SRCPATH"
	CONTRIB_LDFLAGS="$CONTRIB_LDFLAGS -L$NEWLIB_BUILDPATH"
])

AC_DEFUN([VISTALAB_USEBUILTINVIGRA],[
	INCLUDE_SUBDIRS="vigra"
	VIGRA_SRCPATH='$(top_srcdir)/include/vigra'
	CONTRIB_CXXFLAGS="$CONTRIB_CXXFLAGS -I$VIGRA_SRCPATH"
])
