/***************************************************************************
                      autostopper.cpp  -  description
                            -------------------
    begin                : Mon Aug 08 2005
    copyright            : (C) 2005 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#include "autostopper.h"

////////////////////////////// Public Functions /////////////////////////////

BEGIN_CONFIG(autoStopper,vistaLab::module)
    CONFIGPARAMETER(m_numberOfFrames,__("Number of frames before stopping"))
END_CONFIG()

/***************************************************************************/
/*!
 *  Constructor sets up default number of frames
 *
 ***************************************************************************/
autoStopper::autoStopper() :
vistaLab::module(INPUT,__("Miscellaneous"),__("Auto Stopper"),
__("Stops processing after a given number of frames"),
"Fabian Wenzel","wenzel@tu-harburg.de"),
m_numberOfFrames(1)
{
}


/***************************************************************************/
/*!
 *  Does nothing
 *
 ***************************************************************************/
bool autoStopper::init()
{
    return true;
}


/***************************************************************************/
/*!
 *  Nothing
 *
 ***************************************************************************/
void autoStopper::done()
{
}


/***************************************************************************/
/*!
 *
 *
 ***************************************************************************/
bool autoStopper::process()
{
    if(currentFrameNumber() >= m_numberOfFrames){
        vistaLab::setError(_("Automatic stop."));
        return false;
    }

    return true;
}
