/***************************************************************************
                      cannyfilter.h  -  description
                            -------------------
    begin                : Tue Feb 19 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _CANNYFILTER_H_
#define _CANNYFILTER_H_

#include "vlmodule.h"
#include <vigra/stdimage.hxx>

/***************************************************************************/
//! Canny line filter. Currently this filter does nothing.
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class cannyFilter : public vistaLab::module {
    VISTALABMODULE(cannyFilter);
public:
    cannyFilter();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    INPUTPIN (vigra::BImage, m_inputImage     );
    OUTPUTPIN(vigra::BImage, m_edgeImage      );
    PARAMETER(double       , m_scale          );
    PARAMETER(double       , m_threshold      );
    PARAMETER(int          , m_edgeIndicator  );
    PARAMETER(int          , m_noEdgeIndicator);
};

#endif // #ifndef _CANNYFILTER_H_
