/***************************************************************************
                     chronostart.cpp  -  description
                            -------------------
    begin                : Tue Feb 19 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#include "chronostart.h"

using namespace std;

//////////////////////////// Public Functions /////////////////////////////

BEGIN_CONFIG(chronoStart,vistaLab::module)
    CONFIGOUTPUTPIN(m_stopWatch,__("Stopwatch"))
END_CONFIG()

/***************************************************************************/
/*!
 *  
 *
 ***************************************************************************/
chronoStart::chronoStart() :
vistaLab::module(PROCESSING,__("Miscellaneous"),__("Stopwatch Starter"),
__("Used together with Stopwatch Stopper to measure processing time"),
"Fabian Wenzel","wenzel@tu-harburg.de")
{
}


/***************************************************************************/
/*!
 *  There is no initialization
 *
 ***************************************************************************/
bool chronoStart::init()
{
    return true;
}


/***************************************************************************/
/*!
 *  There is no cleaning up
 *
 ***************************************************************************/
void chronoStart::done()
{
}


/***************************************************************************/
/*!
 *  Add a stopWatch to the first frame
 *
 ***************************************************************************/
bool chronoStart::process()
{
    m_stopWatch = new wxStopWatch();
    return true;
}
