/***************************************************************************
                       chronostart.h  -  description
                            -------------------
    begin                : Tue Feb 19 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _CHRONOSTART_H_
#define _CHRONOSTART_H_

#include "vlmodule.h"
#include <wx/timer.h>

/***************************************************************************/
//! Used in conjunction with chronoStop to measure processing time
/*!
 *  To measure processing time (i.e. the time of a set of process() - calls)
 *  a pair of chronoStart and chronoStop - modules may be used.
 *  They have to be placed before and after the modules which should be
 *  measured. The chronoStop - module must select the corresponding
 *  start - module in its configuration dialog. If drawing of the
 *  stop - module is active, the consumed time (and the resulting framerate
 *  which would be possible for realtime processing) is displayed in a
 *  child window.
 *
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class chronoStart : public vistaLab::module  {
    VISTALABMODULE(chronoStart);
public:
    chronoStart();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    OUTPUTPIN(wxStopWatch, m_stopWatch);
};

#endif // #ifndef _CHRONOSTART_H_
