/***************************************************************************
                      deinterlacer.h  -  description
                            -------------------
    begin                : Fri Jun 21 2002
    copyright            : (C) 2002 by wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _DEINTERLACER_H_
#define _DEINTERLACER_H_

#include "vlmodule.h"

#include <vigra/stdimage.hxx>

/***************************************************************************/
//! Deinterlacing of an image
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/

class deinterlacer : public vistaLab::module  {
    VISTALABMODULE(deinterlacer);
public:
    deinterlacer();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    INPUTPIN (vigra::BRGBImage, m_inputImage       );
    OUTPUTPIN(vigra::BRGBImage, m_deinterlacedImage);
    PARAMETER(bool,             m_fillEmptyLines   );
};

#endif
