/***************************************************************************
                       delayline.h  -  description
                            -------------------
    begin                : Fri Jan 18 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _DELAYLINE_H_
#define _DELAYLINE_H_

#include "vlmodule.h"

#include <vector>
#include <vigra/stdimage.hxx>

/***************************************************************************/
//! Gets fed by a source channel and stores a copy of the image
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class delayLine : public vistaLab::module{
    VISTALABMODULE(delayLine);
public:
    delayLine();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    //! The buffer itself
    std::vector< vigra::BRGBImage *> m_buffer;

    // Members related to bufferhandling

    INPUTPIN (vigra::BRGBImage, m_inputImage  );
    OUTPUTPIN(vigra::BRGBImage, m_outputImage );
    PARAMETER(int             , m_bufferLength);

    std::vector< vigra::BRGBImage *>::iterator m_currentImage;
};

#endif // #ifndef _DELAYLINE_H_
