/***************************************************************************
                      differenceimage.cpp  -  description
                            -------------------
    begin                : Mon Nov 25 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#include "differenceimage.h"

#include <vigra/combineimages.hxx>
#include <vigra/functorexpression.hxx>

//////////////////////////// Public Functions /////////////////////////////

BEGIN_CONFIG(differenceImage,vistaLab::module)
    CONFIGINPUTPIN (m_firstInputImage,  __("First Input Image" ))
    CONFIGINPUTPIN (m_secondInputImage, __("Second Input Image" ))
    CONFIGOUTPUTPIN(m_outputImage,      __("Output Image")      )
END_CONFIG()

/***************************************************************************/
/*!
 *
 *
 ***************************************************************************/
differenceImage::differenceImage() :
vistaLab::module(PROCESSING,_("Miscellaneous"),wxString(__("Difference image")),
__("Builds the difference of two Gray images"),
"Fabian Wenzel","wenzel@tu-harburg.de")
{
}


/***************************************************************************/
/*!
 *  There is not initialization
 *
 ***************************************************************************/
bool differenceImage::init()
{
    return true;
}


/***************************************************************************/
/*!
 *  There is no cleaning up
 *
 ***************************************************************************/
void differenceImage::done()
{
}



/***************************************************************************/
/*!
 *
 *
 ***************************************************************************/
bool differenceImage::process(){

    using namespace vigra::functor;

    m_outputImage = new vigra::BImage(m_firstInputImage->width(),m_firstInputImage->height());

    combineTwoImages(srcImageRange(*m_firstInputImage),srcImage(*m_secondInputImage),
                     destImage(*m_outputImage),abs(Arg1()-Arg2()));

    return true;
}
