/***************************************************************************
                    differenceimage.h  -  description
                            -------------------
    begin                : Mon Nov 25 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _DIFFERENCEIMAGE_H_
#define _DIFFERENCEIMAGE_H_

#include "vlmodule.h"

#include <vigra/stdimage.hxx>

/***************************************************************************/
//! Calculates the absolute difference of two images
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class differenceImage : public vistaLab::module {
    VISTALABMODULE(differenceImage);
public:
    differenceImage();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    INPUTPIN (vigra::BImage, m_firstInputImage );
    INPUTPIN (vigra::BImage, m_secondInputImage);
    OUTPUTPIN(vigra::BImage, m_outputImage     );
};


#endif // #ifndef _DIFFERENCEIMAGE_H_

