/***************************************************************************
                   emptyimagegenerator.cpp  -  description
                            -------------------
    begin                : Fri Nov 16 2001
    copyright            : (C) 2001 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#include "emptyimagegenerator.h"
#include <algorithm>


//////////////////////////////// Public Functions ////////////////////////////////


BEGIN_CONFIG(emptyImageGenerator,vistaLab::module)
    CONFIGOUTPUTPIN(m_outputImage,__("Output Image"))
    CONFIGPARAMETER(m_width,__("Image Width in Pixels"))
    CONFIGPARAMETER(m_height,__("Image Height in Pixels"))
    CONFIGPARAMETER(m_red,__("Value for red channel"))
    CONFIGPARAMETER(m_green,__("Value for green channel"))
    CONFIGPARAMETER(m_blue,__("Value for blue channel"))
END_CONFIG()

/***************************************************************************/
/*!
 *  
 *
 ***************************************************************************/
emptyImageGenerator::emptyImageGenerator() :
vistaLab::module(INPUT,__("Input"),__("Empty RGB Image"),
__("Generates a clean RGB image"),
"Fabian Wenzel","wenzel@tu-harburg.de"),
m_width(320),
m_height(240),
m_red(0),
m_green(0),
m_blue(0)
{
}


/***************************************************************************/
/*!
 *  Does nothing
 *
 ***************************************************************************/
bool emptyImageGenerator::init()
{
    return true;
}


/***************************************************************************/
/*!
 *  Does nothing
 *
 ***************************************************************************/
void emptyImageGenerator::done()
{
}


/***************************************************************************/
/*!
 *  If the end of the stream has not been hit ( which will be only when
 *  this function is called for the first time - see
 *  emptyImageGenerator::prepareNextImage() ), a new image is being read.
 *
 ***************************************************************************/
bool emptyImageGenerator::process()
{
    m_outputImage = new vigra::BRGBImage(m_width,m_height,
                    vigra::RGBValue< unsigned char >(m_red,m_green,m_blue));

    return true;
}
