/***************************************************************************
                   emptyimagegenerator.h  -  description
                            -------------------
    begin                : Thu Jul 18 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _EMPTYIMAGEGENERATOR_H_
#define _EMPTYIMAGEGENERATOR_H_

#include "vlmodule.h"
#include <vigra/stdimage.hxx>

/***************************************************************************/
//! An input stream which generates empty images (for only rendering)
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class emptyImageGenerator : public vistaLab::module  {
    VISTALABMODULE(emptyImageGenerator);
public:
    emptyImageGenerator();
    virtual bool init();
    virtual void done();
    virtual bool process();
private:
    OUTPUTPIN(vigra::BRGBImage, m_outputImage);
    PARAMETER(int             , m_width      );
    PARAMETER(int             , m_height     );
    PARAMETER(int             , m_red        );
    PARAMETER(int             , m_green      );
    PARAMETER(int             , m_blue       );

};

#endif // #ifndef _EMPTYIMAGEGENERATOR_H_
