/***************************************************************************
                   grayimagenormalizer.h  -  description
                            -------------------
    begin                : Wed, Jul 17 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _GRAYIMAGENORMALIZER_H_
#define _GRAYIMAGENORMALIZER_H_

#include "vlmodule.h"

#include <vigra/stdimage.hxx>

/***************************************************************************/
//! Processor - Plugin: Normalizes the intensities of a gray image
/*!
 *
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class grayImageNormalizer : public vistaLab::module {
    VISTALABMODULE(grayImageNormalizer);
public:
    grayImageNormalizer();
    virtual bool init();
    virtual void done();
    virtual bool process();
private:
    INPUTPIN (vigra::BImage, m_inputImage     );
    OUTPUTPIN(vigra::BImage, m_normalizedImage);
};

#endif // #ifndef _GRAYIMAGENORMALIZER_H_
