/***************************************************************************
                   graytorgbconverter.cpp  -  description
                            -------------------
    begin                : Mon Jul 29 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#include "graytorgbconverter.h"

#include <vigra/stdimage.hxx>
#include <vigra/copyimage.hxx>
#include <vigra/rgbvalue.hxx>

using namespace std;
using namespace vigra;


//////////////////////////// Public Functions /////////////////////////////

BEGIN_CONFIG(grayToRGBConverter,vistaLab::module)
    CONFIGINPUTPIN (m_inputImage ,__("Input Image" ))
    CONFIGOUTPUTPIN(m_outputImage,__("Output Image"))
END_CONFIG()

/***************************************************************************/
/*!
 *
 *
 ***************************************************************************/
grayToRGBConverter::grayToRGBConverter() :
vistaLab::module(PROCESSING,__("Colorspace"),__("Gray to RGB Converter"),
__("Converts a gray image to an RGB one"),
"Fabian Wenzel","wenzel@tu-harburg.de")
{
}


/***************************************************************************/
/*!
 *  There is not initialization
 *
 ***************************************************************************/
bool grayToRGBConverter::init()
{
    return true;
}


/***************************************************************************/
/*!
 *  There is no cleaning up
 *
 ***************************************************************************/
void grayToRGBConverter::done()
{
}


/***************************************************************************/
/*!
 *
 *
 ***************************************************************************/
bool grayToRGBConverter::process(){

    m_outputImage = new BRGBImage(m_inputImage->size());

    copyImage(srcImageRange(*m_inputImage,GrayToRGBAccessor<BImage::value_type>()),
              destImage(*m_outputImage));

    return true;
}
