/***************************************************************************
                   graytorgbconverter.h  -  description
                            -------------------
    begin                : Mon Feb 29 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _GRAYTORGBCONVERTER_H_
#define _GRAYTORGBCONVERTER_H_

#include "vlmodule.h"
#include <vigra/stdimage.hxx>


/***************************************************************************/
//! Converts a gray image to an RGB one
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class grayToRGBConverter : public vistaLab::module {
    VISTALABMODULE(grayToRGBConverter);
public:
    grayToRGBConverter();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    INPUTPIN (vigra::BImage   , m_inputImage );
    OUTPUTPIN(vigra::BRGBImage, m_outputImage);
};

#endif // #ifndef _GRAYTORGBCONVERTER_H_
