/***************************************************************************
                     harriscorners.h  -  description
                            -------------------
    begin                : Wed May 29 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _HARRISCORNERS_H_
#define _HARRISCORNERS_H_

#include "vlmodule.h"

#include <vigra/stdimage.hxx>

/***************************************************************************/
//! Processor - Plugin: Vigra Harris corner Detector
/*!
 *  The processor uses the harris - algorithm to find corners in the
 *
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class harrisCorners : public vistaLab::module {
    VISTALABMODULE(harrisCorners);
public:
    harrisCorners();
    virtual bool init();
    virtual void done();
    virtual bool process();
private:
    INPUTPIN (vigra::BRGBImage, m_inputImage );
    OUTPUTPIN(vigra::BImage   , m_outputImage);
};

#endif // #ifndef _HARRISCORNERS_H_
