/***************************************************************************
                      imagechannel.h  -  description
                            -------------------
    begin                : Thu Jul 17 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _IMAGECHANNEL_H_
#define _IMAGECHANNEL_H_

#include "vlmodule.h"
#include <vigra/stdimage.hxx>

namespace vistaLab {
class channelWindow;
}

/***************************************************************************/
//! Implements the channel which displays an RGB image in the main frame
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class imageChannel : public vistaLab::module {
    VISTALABMODULE(imageChannel);
public:

    imageChannel();
    virtual ~imageChannel();
    virtual bool init();
    virtual void done();
    virtual bool process();

    virtual void postConfig();

private:
    imageChannel(const imageChannel &src);
    // The ID of the image to render
    INPUTPIN(vigra::BRGBImage,m_inputImage);

    vistaLab::channelWindow *m_channelWindow;
};

#endif // #ifndef _IMAGECHANNEL_H_
