/***************************************************************************
                      imagemultiplier.h  -  description
                            -------------------
    begin                : Fri Aug 30 2002
    copyright            : (C) 2002 by wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _IMAGEMULTIPLIER_H_
#define _IMAGEMULTIPLIER_H_

#include "vlmodule.h"

#include <vigra/stdimage.hxx>

/***************************************************************************/
//! Multiplies and image pixelwise
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class imageMultiplier : public vistaLab::module  {
    VISTALABMODULE(imageMultiplier);
public: 
    imageMultiplier();

    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    INPUTPIN (vigra::BImage, m_firstImage );
    INPUTPIN (vigra::BImage, m_secondImage);
    OUTPUTPIN(vigra::BImage, m_outputImage);
};

#endif // #ifndef _IMAGEMULTIPLIER_H_
