/***************************************************************************
                    imagerenderer.cpp  -  description
                            -------------------
    begin                : Fri Jul 19 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de
 
***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#include "imagerenderer.h"

#include <vigra/stdimage.hxx>

#include "vlconfigmanager.h"
#include "vlpin.h"


using namespace std;


//////////////////////////// Public Functions /////////////////////////////


BEGIN_CONFIG(imageRenderer,vistaLab::module)
    CONFIGINPUTPIN (m_inputImage ,__("Input Image") )
    CONFIGOUTPUTPIN(m_outputImage,__("Output Image"))

    getConfigItems()->push_back(vistaLab::configItem(
        vistaLab::configItem::RENDERINPUTPIN,
        (void *) &m_renderSlots,__("Render Hook")));

END_CONFIG()

/***************************************************************************/
/*!
 *
 *
 ***************************************************************************/
imageRenderer::imageRenderer() :
vistaLab::module(OUTPUT,__("Output"),__("Image Renderer"),
__("Renders an output image"),
"Fabian Wenzel","wenzel@tu-harburg.de")
{
}


/***************************************************************************/
/*!
 *  There is no initialization
 *
 ***************************************************************************/
bool imageRenderer::init()
{
    return true;
}


/***************************************************************************/
/*!
 *  There is no cleaning up
 *
 ***************************************************************************/
void imageRenderer::done()
{
}


/***************************************************************************/
/*!
 *
 *
 ***************************************************************************/
bool imageRenderer::process(){
    // Make a copy to render onto
    m_outputImage = new vigra::BRGBImage(*m_inputImage);

    vector< int >::iterator currentRenderSlot;
    for(currentRenderSlot  = m_renderSlots.begin();
        currentRenderSlot != m_renderSlots.end();
        ++currentRenderSlot){

        // Call each renderpin
        vistaLab::renderPin *currentRenderPin =
            vistaLab::configManager::getManager().getRenderPins()[*currentRenderSlot];

        if(currentRenderPin->m_moduleInstance->isActive() &&
           currentRenderPin->m_moduleInstance->isValid())

            ((currentRenderPin->m_moduleInstance)->*
            (currentRenderPin->m_renderFunction))(m_outputImage);
    }

    return true;
}
