/***************************************************************************
                     imagerenderer.h  -  description
                            -------------------
    begin                : Fri Jul 19 2001
    copyright            : (C) 2001 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _IMAGERENDERER_H_
#define _IMAGERENDERER_H_

#include "vlmodule.h"

#include <vigra/stdimage.hxx>


/***************************************************************************/
//! Does no processing but displays the input image and renders information
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class imageRenderer : public vistaLab::module {
    VISTALABMODULE(imageRenderer)
public:
    imageRenderer();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    INPUTPIN (vigra::BRGBImage, m_inputImage )
    OUTPUTPIN(vigra::BRGBImage, m_outputImage)

    std::vector< int >          m_renderSlots;
};

#endif // #ifndef _IMAGERENDERER_H_
