/***************************************************************************
                   imagesequencewriter.h  -  description
                            -------------------
    begin                : Wed, Apr 23 2003
    copyright            : (C) 2003 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _IMAGESEQUENCEWRITER_H_
#define _IMAGESEQUENCEWRITER_H_

#include "vlmodule.h"

#include <vector>
#include <string>


/***************************************************************************/
//! OUTPUT - Plugin:
/*!
 *
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class imageSequenceWriter : public vistaLab::module {
    VISTALABMODULE(imageSequenceWriter);
public:
    imageSequenceWriter();
    virtual ~imageSequenceWriter();
    virtual bool init();
    virtual void done();
    virtual bool process();
private:
    PARAMETER  (int                         , m_quality    );
    PARAMETER  (vistaLab::fileName          , m_fileName   );
    INPUTPIN   (vigra::BRGBImage            , m_inputImage );
    CHOICEPARAM(vistaLab::singleChoice<int> , m_imageType  );

    static std::vector< int >         m_imageTypes;
    static std::vector< std::string > m_imageTypeDescriptions;
    static std::vector< std::string > m_imageTypeSuffixes;

    int                                       m_frameCounter;

    enum EImageType {
        PNG,
        JPG,
        BMP
    };
};

#endif // #ifndef _IMAGESEQUENCEWRITER_H_
