/***************************************************************************
                    inputstreamimage.h  -  description
                            -------------------
    begin                : Fri Nov 16 2001
    copyright            : (C) 2001 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _INPUTSTREAMIMAGE_H_
#define _INPUTSTREAMIMAGE_H_

#include "vlinputstreamfile.h"

#include <vigra/stdimage.hxx>

/***************************************************************************/
//! An input stream which reads a single file and then stops
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class inputStreamImage : public vistaLab::inputStreamFile  {
    VISTALABMODULE(inputStreamImage);
public:
    inputStreamImage();
    virtual bool process();
private:
    OUTPUTPIN(vigra::BRGBImage, m_outputImage);
    PARAMETER(bool            , m_showOnce   );
};

#endif
