/***************************************************************************
                      integerscaler.h  -  description
                            -------------------
    begin                : Wed, Jul 17 2002
    copyright            : (C) 2002 by AUTHOR
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _INTEGERSCALER_H_
#define _INTEGERSCALER_H_

#include "vlmodule.h"

/***************************************************************************/
//! Processor - Plugin: Scales an image an integer number of times
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class integerScaler : public vistaLab::module {
    VISTALABMODULE(integerScaler);
public:
    integerScaler();
    virtual bool init();
    virtual void done();
    virtual bool process();
private:
    INPUTPIN (vigra::BRGBImage, m_inputImage );
    OUTPUTPIN(vigra::BRGBImage, m_outputImage);
    PARAMETER(int,              m_factor     );
};

#endif // #ifndef _INTEGERSCALER_H_
