/***************************************************************************
                        logfile.h  -  description
                            -------------------
    begin                : Tue May 27 2003
    copyright            : (C) 2003 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _LOGFILE_H_
#define _LOGFILE_H_

#include "vlmodule.h"
#include <fstream>
#include <vector>

/***************************************************************************/
//! Implements a log file which stores log messages
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class logFile : public vistaLab::module {
    VISTALABMODULE(logFile);
public:
    logFile();
    virtual ~logFile();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    std::vector< int > m_logSlots;
    std::fstream      *m_logFile;
    char               m_fullFileName[255];
    int                m_frameCounter;

    PARAMETER(bool                  , m_separateFile);
    PARAMETER(bool                  , m_annotations );
    PARAMETER(vistaLab::saveFileName, m_fileName    );
};

#endif // #ifndef _LOGFILE_H_
