/***************************************************************************
                  rgbtograyconverter.cpp  -  description
                            -------------------
    begin                : Mon Jul 29 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#include "rgbtograyconverter.h"

#include <vigra/stdimage.hxx>
#include <vigra/copyimage.hxx>

using namespace std;
using namespace vigra;

//////////////////////////// Public Functions /////////////////////////////

BEGIN_CONFIG(RGBToGrayConverter,vistaLab::module)
    CONFIGINPUTPIN (m_inputImage, __("Input Image") )
    CONFIGOUTPUTPIN(m_outputImage,__("Output Image"))
END_CONFIG()

/***************************************************************************/
/*!
 *  
 *
 ***************************************************************************/
RGBToGrayConverter::RGBToGrayConverter() :
vistaLab::module(PROCESSING,__("Colorspace"),__("RGB to Gray Converter"),
__("Converts an RGB image to a gray one"),
"Fabian Wenzel","wenzel@tu-harburg.de")
{
}


/***************************************************************************/
/*!
 *  There is no initialization
 *
 ***************************************************************************/
bool RGBToGrayConverter::init()
{
    return true;
}


/***************************************************************************/
/*!
 *  There is no cleaning up
 *
 ***************************************************************************/
void RGBToGrayConverter::done()
{
}


/***************************************************************************/
/*!
 *
 *
 ***************************************************************************/
bool RGBToGrayConverter::process()
{
    m_outputImage = new BImage(m_inputImage->size());

    copyImage(srcImageRange(*m_inputImage,RGBToGrayAccessor< BRGBImage::PixelType >()),
              destImage(*m_outputImage));

    return true;
}
