/***************************************************************************
                     rgbtograyconverter.h  -  description
                            -------------------
    begin                : Mon Feb 29 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _RGBTOGRAYCONVERTER_H_
#define _RGBTOGRAYCONVERTER_H_

#include "vlmodule.h"

#include <vigra/stdimage.hxx>

/***************************************************************************/
//! Converts an RGB image to a gray one
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class RGBToGrayConverter : public vistaLab::module {
    VISTALABMODULE(RGBToGrayConverter);
public:
    RGBToGrayConverter();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    INPUTPIN (vigra::BRGBImage,m_inputImage );
    OUTPUTPIN(vigra::BImage   ,m_outputImage);
};

#endif
