/***************************************************************************
                        rotator.h  -  description
                            -------------------
    begin                : Mon Jun 3 2002
    copyright            : (C) 2002 by wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _ROTATOR_H_
#define _ROTATOR_H_

#include <vigra/stdimage.hxx>
#include <vector>
#include <string>

#include "vlmodule.h"


/***************************************************************************/
//! Rotates an image by multiples of 90 degrees
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/

class rotator : public vistaLab::module  {
    VISTALABMODULE(rotator);
public:
    rotator();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:

    INPUTPIN (vigra::BRGBImage, m_inputImage   );
    OUTPUTPIN(vigra::BRGBImage, m_rotatedImage );
    PARAMETER(int             , m_numOf90DegCCW);
};

#endif // #ifndef _ROTATOR_H_
