/***************************************************************************
                      sobelfilter.h  -  description
                            -------------------
    begin                : Tue Feb 19 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _SOBELFILTER_H_
#define _SOBELFILTER_H_

#include "vlmodule.h"
#include <vigra/stdimage.hxx>


/***************************************************************************/
//! Filters a gray image by a sobel filter
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/
class sobelFilter : public vistaLab::module {
    VISTALABMODULE(sobelFilter);
public:
    sobelFilter();
    virtual bool init();
    virtual void done();
    virtual bool process();

private:
    INPUTPIN (vigra::BImage, m_inputImage );
    OUTPUTPIN(vigra::BImage, m_outputImage);
};

#endif // #ifndef _SOBELFILTER_H_
