/***************************************************************************
                      thresholder.h  -  description
                            -------------------
    begin                : Fri Aug 30 2002
    copyright            : (C) 2002 by wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _THRESHOLDER_H
#define _THRESHOLDER_H

#include "vlmodule.h"

#include <vigra/stdimage.hxx>

/***************************************************************************/
//! Thresholding of an image
/*!
 * \ingroup Modules
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/

class thresholder : public vistaLab::module  {
    VISTALABMODULE(thresholder)
public:
    thresholder();
    virtual bool init();
    virtual void done();
    virtual bool process();

    const char *checkValues();

private:
    INPUTPIN (vigra::BImage ,m_inputImage      )
    OUTPUTPIN(vigra::BImage ,m_thresholdedImage)
    PARAMETER(int           ,m_threshold       )
    PARAMETER(int           ,m_lowValue        )
    PARAMETER(int           ,m_highValue       )
};


#endif // #ifndef _THRESHOLDER_H
