/***************************************************************************
                      vlconfigitem.cpp -  description
                            -------------------
    begin                : Mon Dec 19 2003
    copyright            : (C) 2003 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/


#include "vlconfigitem.h"

using namespace vistaLab;

class module;
class configurableObject;
class slice;


////////////////////////// Misc Functions/Classes ///////////////////////////


/***************************************************************************/
/*!
 *  Constructor takes a void target pointer
 *
 ***************************************************************************/
configItem::configItem(const EType type,
                       const void *target,
                       const std::string &description,
                       const std::vector< std::string > &selections) :
m_type(type),
m_description(description),
m_localizedDescription(_(description.c_str())),
m_selections(selections)
{
    m_target.data = target;
}


/***************************************************************************/
/*!
 *  Constructor takes a validator function pointer
 *
 ***************************************************************************/
configItem::configItem(const EType type,
                       const TMemberFunc targetFunc,
                       const std::string &description,
                       const std::vector< std::string > &selections) :
m_type(type),
m_description(description),
m_localizedDescription(_(description.c_str())),
m_selections(selections)
{
    m_target.func = targetFunc;
}
