/***************************************************************************
                       vlinputthread.cpp  -  description
                            -------------------
    begin                : Thu Nov 22 2001
    copyright            : (C) 2001 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#include "vlinputthread.h"

#include "vlapp.h"
#include "vldocument.h"
#include "vlprocessor.h"
#include "vlmodule.h"
#include "vlslice.h"
#include "vlconfigmanager.h"

using namespace vistaLab;


////////////////////////////// Public functions ////////////////////////////


/***************************************************************************/
/*!
 *  Constructor creates the thread as detached thread
 *
 ****************************************************************************/
inputThread::inputThread(module *attachedModule) :
wxThread(wxTHREAD_JOINABLE),
m_attachedModule(attachedModule)
{
    Create();
}


/***************************************************************************/
/*!
 *  The main loop for the thread
 *
 ****************************************************************************/
wxThread::ExitCode inputThread::Entry()
{
    // For handing images to the framework
    document *myDocument = wxGetApp().getDocument();

    // This slice is for getting new data from the attached module only
    // It gets merged with the "target slice" in CDocument::addData()
    slice ownSlice;

    // Okay, everything is initialized, so loop in fetching frames
    // until we should stop
    while(wxGetApp().getProcessor()->isRunning()){

        // Is there a new image?
        if(m_attachedModule->process(ownSlice)){

            // Add it to the document
            myDocument->addData(m_attachedModule,&ownSlice);

        } else
            // There is no new image :-(
            wxGetApp().getProcessor()->stop();
    }

    return 0;
}
