/***************************************************************************
                      vlinputthread.h  -  description
                            -------------------
    begin                : Thu Nov 22 2001
    copyright            : (C) 2001 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _VLINPUTTHREAD_H_
#define _VLINPUTTHREAD_H_


#include <wx/thread.h>

namespace vistaLab {

class module;


/***************************************************************************/
//! The input thread which acquires images autonomously
/*!
 *  If a module is required to run in an own thread (e.g. because of
 *  blocking I/O), it gets wrapped in this thread class which gets
 *  created on each run and hands new read frames to the document which
 *  merges them and notifies the processor core when ready for processing
 *
 *  \author  Fabian Wenzel
 *
 ***************************************************************************/
class inputThread : public wxThread {
public:
    inputThread(module *attachedModule);
    ExitCode Entry();

private:

    // The connected module
    module       *m_attachedModule;
};

} // namespace vistaLab

#endif // #ifndef _VLINPUTTHREAD_H_
