/***************************************************************************
                       vlmodule.cpp  -  description
                            -------------------
    begin                : Mon Feb 4 2002
    copyright            : (C) 2002 by Fabian Wenzel
    eMail                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#include "vlmodule.h"

using namespace std;
using namespace vistaLab;

string module::m_error;
int    module::m_processedFramesCounter;


/***************************************************************************/
/*!
 *  Global function: sets error value
 *
 ***************************************************************************/
void module::setError(const char *error)
{
    m_error = error;
}


/***************************************************************************/
/*!
 *  Global function: gets error value
 *
 ***************************************************************************/
const string module::getError()
{
    string result = m_error;
    m_error = _("Unknown Error.");
    return result;
}


//////////////////// CVistaConfigurableObject - Classes /////////////////////



/***************************************************************************/
/*!
 *  Adds a configurable item to the config manager
 *
 ***************************************************************************/
void configurableObject::addConfig(configItem::EType type, const void *target,
                                   const std::string &description,
                                   const std::vector< std::string > &selections)
{
    getConfigItems()->push_back(configItem(type,target,description,selections));
}


/***************************************************************************/
/*!
 *  Adds a validator/render/log-function to the config manager
 *
 ***************************************************************************/
void configurableObject::addConfigFunc
(configItem::EType type,
 configItem::TMemberFunc func,
 const std::string &description )
{
    getConfigItems()->push_back(configItem(type, func, description));
}


////////////////////////////// Public Functions //////////////////////////////

BEGIN_CONFIG_TOPOBJECT(module)
    CONFIGPARAMETER(m_instanceName,__("Instancename"))
    getConfigItems()->push_back(configItem(configItem::ACTIVEBOOL,
                            (void *) &m_active,__("Active")));
END_CONFIG()


/***************************************************************************/
/*!
 *  Constructor initializes members with their passed values
 *
 ***************************************************************************/
module::module(EModuleClass moduleClass,
               const char *moduleCategory,
               const char *name, const char *helpString,
               const char *author, const char *eMail) :
configurableObject(name),
m_moduleClass           (moduleClass),
m_instanceName          (_(name)),
m_moduleCategory        (moduleCategory),
m_helpString            (_(helpString)),
m_active                (true),
m_valid                 (true)
{
    m_authorEMail = string(author)+" <"+string(eMail)+">";
}
