/***************************************************************************
                      vlmoduleconfig.h  -  description
                            -------------------
    begin                : Mon Feb 4 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _VLMODULECONFIG_H_
#define _VLMODULECONFIG_H_

namespace vistaLab {

class configurableObject;

/***************************************************************************/
//! An (almost completely) abstract class for configuration handling
/*!
 *
 * The only thing which is not abstract is handling of validator - functions
 * as they may be used in many childs
 *
 * \author  Fabian Wenzel
 *
 ***************************************************************************/

class moduleConfig{
public:
    virtual bool configure()=0;
    virtual void attachModule(configurableObject *module)
    {
        m_targetModule=module;
    }

    virtual ~moduleConfig() {}

protected:
    configurableObject *m_targetModule;
};

class moduleConfigFileBase : public moduleConfig{
public:
    virtual void save()=0;
};

} // vistaLab

#endif // #ifndef _VLMODULECONFIG_H_
