/***************************************************************************
                   vlmoduleconfigfile.h  -  description
                            -------------------
    begin                : Mon Feb 4 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _VLMODULECONFIGFILE_H_
#define _VLMODULECONFIGFILE_H_

#include "vlmoduleconfig.h"

#include <wx/config.h>
#include <wx/fileconf.h>

#include <vector>

class wxFileConfig;

namespace vistaLabFileItems{
    class configFileItemBase;
}

namespace vistaLab {

/***************************************************************************/
//! The file backend for the configuration implementation using files
/*!
 *  \author  Fabian Wenzel
 *
 ***************************************************************************/
class moduleConfigFile : public moduleConfigFileBase {
    friend class vistaLabFileItems::configFileItemBase;
public:
    typedef std::vector< vistaLabFileItems::configFileItemBase *>
        TConfigFileItems;

    moduleConfigFile      (wxFileConfig *config);
    virtual ~moduleConfigFile();

    // The "actions" - interface (whereas "save" is only used internally!)
    void save              ();
    virtual bool configure ();
    virtual void attachModule(configurableObject *module);

private:
    void addConfigItems();

    TConfigFileItems m_fileConfigItems;
    wxFileConfig *p_config;
};

} // namespace vistaLab

#endif // #ifndef _VLMODULECONFIGFILE_H_
