/***************************************************************************
                               vlmoduleconfigxml.h  -  description
                            -------------------
         begin                : Tue Aug 3 2004
         copyright            : (C) 2004 by Fabian Wenzel
         email                : wenzel@tu-harburg.de

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

 #ifndef _VLMODULECONFIGXML_H_
 #define _VLMODULECONFIGXML_H_

 #include "vlmoduleconfig.h"
 #include <vector>
 #include <libxml/tree.h>

namespace vistaLabXMLItems{
    class configXMLItemBase;
}

namespace vistaLab {


/***************************************************************************/
//! The file backend for the configuration implementation using files
/*!
 *  \author  Fabian Wenzel
 *
 ***************************************************************************/

class moduleConfigXML : public moduleConfigFileBase {
friend class vistaLabXMLItems::configXMLItemBase;
public:
    typedef std::vector< vistaLabXMLItems::configXMLItemBase *>
         TConfigXMLItems;

    moduleConfigXML      (xmlNodePtr XMLNode);
    virtual ~moduleConfigXML();

    virtual void attachModule(configurableObject *module);
    // The "actions" - interface (whereas "save" is only used internally!)
    void save              ();
    virtual bool configure ();

private:
    void addConfigItems();
    void clearConfigItems();

    xmlNodePtr p_XMLNode;
    TConfigXMLItems m_XMLConfigItems;
};

} // namespace vistaLab

 #endif // #ifndef _VLMODULECONFIGXML_H_
