/***************************************************************************
                       vlprojectconfig.h  -  description
                            -------------------
    begin                : Tue Aug 3 2004
    copyright            : (C) 2004 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _VLPROJECTCONFIG_H_
#define _VLPROJECTCONFIG_H_

namespace vistaLab {

class moduleConfigFileBase;

/***************************************************************************/
//! The file backend for the configuration implementation using files
/*!
 *  \author  Fabian Wenzel
 *
 ***************************************************************************/
class projectConfig {
public:
    projectConfig()
    {
    }

    virtual ~projectConfig()
    {
    }

    virtual void prepareGlobalGroup(const char *groupName, bool enterGroup=1)=0;
    virtual bool hasNextModule()=0;
    virtual const char *readNextModule()=0;
    virtual void writeNextModule(const char *moduleName)=0;
    virtual moduleConfigFileBase &getConfigurizer()=0;
};

} // namespace vistaLab

#endif // #ifndef _VLPROJECTCONFIG_H_
