/***************************************************************************
                      vlslice.cpp  -  description
                          -------------------
    begin                : Fri Nov 16 2001
    copyright            : (C) 2001 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#include "vlslice.h"

#include <algorithm>
#include <boost/bind.hpp>

#include "vlconfigmanager.h"
#include "vlapp.h"
#include "vlprocessor.h"

using namespace vistaLab;

/***************************************************************************/
/*!
 *  Constructor initializes the slice with number of channels and sets
 *  all frame pointers to zero.
 *
 ***************************************************************************/
slice::slice():
std::vector< void *>(configManager::getManager().getEntries(),(void *) 0),
m_validEntries(0) {}


slice::~slice()
{
    TActiveModules  modules =
        wxGetApp().getProcessor()->getModules();

    std::for_each(modules.begin(),modules.end(),
        boost::bind(&vistaLab::module::cleanup,_1,boost::ref(*this)));
}

