/***************************************************************************
                        vlview.h  -  description
                            -------------------
    begin                : Tue Jan 8 2002
    copyright            : (C) 2002 by Fabian Wenzel
    email                : wenzel@tu-harburg.de

***************************************************************************/

/***************************************************************************
 *                                                                         *
 * This file is released under the the terms of the VistaLab public        *
 * License V1.5. See file COPYING for details.                             *
 *                                                                         *
 ***************************************************************************/

#ifndef _VLVIEW_H_
#define _VLVIEW_H_

#include <wx/scrolwin.h>

class wxBoxSizer;
class imageChannel;


namespace vistaLab {

class module;

/***************************************************************************/
//! The scrolled windows which stores all input channel windows
/*!
 *  \author  Fabian Wenzel
 *
 ***************************************************************************/
class channelWindow;

class view : public wxScrolledWindow {
public:
    view(wxWindow* parent);

    // Members for adding / removing channels
    channelWindow *addChannel   (imageChannel *channel);
    void removeChannel(channelWindow *window);

    //! Called by a child window if its size changes (for scrollbars)
    void updatePanelSize();

    //! Called when adding a new child as the panel is a parent for new childs
    wxPanel *getPanel() { return m_panel; }
private:

    wxPanel    *m_panel;
    wxBoxSizer *m_channelSizer;
};

} // namespace vistaLab

#endif // #ifndef _VLVIEW_H_
